<?php

namespace App\Models\Equipment;

use App\Entities\Equipment\PartEntity;

class PartModel extends EquipmentModel
{
    const TABLE = "partinfo";
    const PK = "uid";
    const TITLE = "title";
    protected $table            = self::TABLE;
    protected $primaryKey       = self::PK;
    protected $returnType       = PartEntity::class;
    protected $allowedFields = [
        "type",
        "title",
        "price",
        "status",
        "updated_at"
    ];
    public function __construct()
    {
        parent::__construct();
    }
    final public function getFormFieldRule(string $action, string $field): string
    {
        if (is_array($field)) {
            throw new \Exception(__FUNCTION__ . "=> field가 array 입니다.\n" . var_export($field, true));
        }
        switch ($field) {
            case "type":
            case "status":
                $rule = "required|trim|string";
                break;
            case "price":
                $rule  = "required|numeric";
                break;
            default:
                $rule = parent::getFormFieldRule($action, $field);
                break;
        }
        return $rule;
    }
}
